package com.Goldenstreet.App.GoldenStreet;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.json.JSONException;
import org.json.JSONObject;

import com.Goldenstreet.App.R;
import com.LibreGeoSocial.Api.LibreGeoSocial;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

/**
 * Clase auxiliar encargada de realizar la construccin sobre una propiedad (calle) en posesin del equipo.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class AccionMenuConstruir{
	private static String TAG = "AccionMenuConstruir";
	
	private static Context context;
	private static Calle calle;	
	private static Carta carta;
	private static boolean usarCarta = false;
	private static ProgressDialog progressDialog = null;
	
	public static void construirCalleMapa(Context context, Calle calle){
		AccionMenuConstruir.context = context;
		AccionMenuConstruir.calle = calle;
		if (calle != null)
			ConstruirCalle();
	}		
	
	private static void ConstruirCalle(){
		usarCarta = false;
		carta = Carta.encontrarPorTipoSinUsar(CartaServicio.getCartasEquipo(), Carta.CONSTRUIR);
		String message = String.format(context.getString(R.string.infoConstruir), calle.getNombre(), calle.getPrecioEdificio());
		if (carta != null){
			AlertDialog.Builder builder = new AlertDialog.Builder(context);
			builder.setMessage(message)
			       .setCancelable(false)
	    	       .setPositiveButton(context.getString(R.string.butSi), new DialogInterface.OnClickListener() {
			           public void onClick(DialogInterface dialog, int id) {
			        	   dialog.cancel();
			        	   String title = context.getString(R.string.espere);
		        	       String text = context.getString(R.string.construirCalle);
		        			
		        	       AccionMenuConstruir.progressDialog = ProgressDialog.show(context, title, text, true, false);
		        	       AccionMenuConstruir.progressDialog.setIcon(R.drawable.ic_dialog_conexion);
		        	       
				   	       Thread thread = new Thread(construirCalle);
				   	       thread.start();
			           }
			       }).setNeutralButton(context.getString(R.string.butCartaUsar), new DialogInterface.OnClickListener() {
	    	           public void onClick(DialogInterface dialog, int id) {
	    	        	   dialog.cancel();
			        	   String title = context.getString(R.string.espere);
		        	       String text = context.getString(R.string.construirCalle);
		        			
		        	       AccionMenuConstruir.progressDialog = ProgressDialog.show(context, title, text, true, false);
		        	       AccionMenuConstruir.progressDialog.setIcon(R.drawable.ic_dialog_conexion);
		        	       usarCarta = true;
		        	       
				   	       Thread thread = new Thread(construirCalle);
				   	       thread.start();
	    	           }
	    	       }).setNegativeButton(context.getString(R.string.butNo), new DialogInterface.OnClickListener() {
	    	           public void onClick(DialogInterface dialog, int id) {
	    	        	   dialog.cancel();
	    	           }
	    	       });
	    	AlertDialog alert = builder.create();
	    	alert.setTitle(context.getString(R.string.construir));
	    	alert.setIcon(R.drawable.ic_dialog_informacion);
	    	alert.show();
		}else{
			AlertDialog.Builder builder = new AlertDialog.Builder(context);
			builder.setMessage(message)
			       .setCancelable(false)
	    	       .setPositiveButton(context.getString(R.string.butSi), new DialogInterface.OnClickListener() {
			           public void onClick(DialogInterface dialog, int id) {
			        	   dialog.cancel();
			        	   String title = context.getString(R.string.espere);
		        	       String text = context.getString(R.string.construirCalle);
		        			
		        	       AccionMenuConstruir.progressDialog = ProgressDialog.show(context, title, text, true, false);
		        	       AccionMenuConstruir.progressDialog.setIcon(R.drawable.ic_dialog_conexion);
		        	       
				   	       Thread thread = new Thread(construirCalle);
				   	       thread.start();
			           }
			       }).setNegativeButton(context.getString(R.string.butNo), new DialogInterface.OnClickListener() {
	    	           public void onClick(DialogInterface dialog, int id) {
	    	        	   dialog.cancel();
	    	           }
	    	       });
	    	AlertDialog alert = builder.create();
	    	alert.setTitle(context.getString(R.string.construir));
	    	alert.setIcon(R.drawable.ic_dialog_informacion);
	    	alert.show();
		}
	}
	
	private static Runnable construirCalle = new Runnable(){
		@Override
		public void run(){
			Looper.prepare();
			conexionConstruirCalle();
			Looper.myLooper().quit();
			Looper.loop();
		}
		
		private void showToastConexion(){			
			Toast toast = Toast.makeText(context,
					context.getString(R.string.errConexion),
					Toast.LENGTH_SHORT);
			toast.show();
		}
		
		private void showToastDatos(){
			Toast toast = Toast.makeText(context,
					context.getString(R.string.errDatos),
					Toast.LENGTH_SHORT);
			toast.show();
		}
		
		private void showToastAceptada(){
			Toast toast = Toast.makeText(context,
					String.format(context.getString(R.string.calleConstruirAceptada),calle.getNombre()),
					Toast.LENGTH_LONG);
			toast.show();
		}
		
		private void showToastSinDinero(){
			Toast toast = Toast.makeText(context,
					String.format(context.getString(R.string.calleComprarSinDinero), calle.getNombre()),
					Toast.LENGTH_LONG);
			toast.show();
		}
		
		private void showToastRechazada(){
			Toast toast = Toast.makeText(context,
					String.format(context.getString(R.string.calleConstruirRechazada), calle.getNombre()),
					Toast.LENGTH_LONG);
			toast.show();
		}
		
		public void conexionConstruirCalle(){
			int resultado;
			try{
				DefaultHttpClient httpclient = new DefaultHttpClient();
				int idJuego = JuegoListar.getJuego().getIdentificador();
				int idEquipo = JuegoDatosListar.getEquipo().getIdentificador();
				int idCalle = AccionMenuConstruir.calle.getId();
				URI uri = new URI(GoldenStreets.urlServer+"juego/"+idJuego+"/equipo/"+idEquipo+"/calle/"+idCalle+"/construir/?format=json");

				HttpPost httpost = new HttpPost(uri);
				LibreGeoSocial LGS = LibreGeoSocial.getInstance();
				httpclient.setCookieStore(LGS.getCookieStore());
					  
				List <NameValuePair> datos = new ArrayList <NameValuePair>();
				if (usarCarta)
					datos.add(new BasicNameValuePair("edificioPrecio", "0"));
				else
					datos.add(new BasicNameValuePair("edificioPrecio", Integer.toString(calle.getPrecioEdificio())));
	            datos.add(new BasicNameValuePair("edificioPrecioOriginal", Integer.toString(calle.getPrecioEdificio())));
	            httpost.setEntity(new UrlEncodedFormEntity(datos, HTTP.UTF_8));
				
	            HttpResponse response = httpclient.execute(httpost);
	            HttpEntity entity = response.getEntity();
	            String str = Utils.deStreamAString(entity.getContent());
				resultado = procesarRespuestaCalleConstruir(str);			

				handler.sendEmptyMessage(resultado);

			}catch(URISyntaxException urisex){
				Log.e(TAG, urisex.getMessage());
				handler.sendEmptyMessage(-1);
		    }catch (IOException e) {
		    	Log.e(TAG,e.getMessage());
		    	handler.sendEmptyMessage(-1);
		    }
		}
		
		private int procesarRespuestaCalleConstruir(String str) {
			int ultCode;
	    	String ultMensaje;
	        try {
	        	JSONObject json;
				json = new JSONObject(str);
				
				if (json.has("code"))
					ultCode = json.getInt("code");
				else
					ultCode = -1;
				
				if (json.has("descripcion"))
					ultMensaje = json.getString("descripcion");
				else
					ultMensaje = null;
				
				if (ultCode != 200){
					if (ultCode == 400 && ultMensaje.toLowerCase().compareTo("sin dinero") == 0)
						return -3;
					if (ultCode == 400 && ultMensaje.toLowerCase().compareTo("calle con modificaciones") == 0)
						return -4;
					return -2;
				}
			} catch (JSONException e) {	
				ultCode = 500;
				ultMensaje = "Error in json parsed: " + e.getMessage();
				Log.e(TAG, ultMensaje);
				return -2;
			}
			return 0;
		}
		
	    private Handler handler = new Handler()
	    {
	    	@Override
	        public void handleMessage(Message msg)
	        {
	        	int result = msg.what;
	        	AccionMenuConstruir.progressDialog.cancel();
	        	if(result == -4){
	        		showToastRechazada();
	        	}else if(result == -3){
	        		showToastSinDinero();
	        	}else if(result == -2){
	        		showToastDatos();
	        	}else if(result == -1){
	        		showToastConexion();
	        	}else if(result == 0){
	        		if (usarCarta)
	        			carta.setUsada(true);
	        		showToastAceptada();
	        	}
	        }
	    };
	};
}