package com.Goldenstreet.App.GoldenStreet;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.json.JSONException;
import org.json.JSONObject;

import com.Goldenstreet.App.R;
import com.LibreGeoSocial.Api.LibreGeoSocial;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

/**
 * Clase auxiliar encargada de realizar la venta de una propiedad (calle) al propio juego.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class AccionMenuVender{
	private static String TAG = "AccionMenuVender";
	
	private static final double PEN_VENTA = 0.10;
	private static final double PEN_VENTA_SABOTEADA = 0.30;
	
	private static Context context;
	private static Calle calle;	
	private static int valorVenta;
	private static int valorTotalCalle;
	private static ProgressDialog progressDialog = null;
	
	
	public static void venderCalleMapa(Context context, Calle calle){
		AccionMenuVender.context = context;
		AccionMenuVender.calle = calle;
		if (calle != null)
			venderCalle();
	}		
	
	private static void venderCalle(){		
		AlertDialog.Builder builder = new AlertDialog.Builder(context);
		if(calle.getEstaConstruido()){
			valorTotalCalle = calle.getPrecio() + calle.getPrecioEdificio();
			if(calle.getEstaSaboteado()){
				valorVenta = (int) (valorTotalCalle * (1 - PEN_VENTA_SABOTEADA));
			}else{
				valorVenta = (int) (valorTotalCalle * (1 - PEN_VENTA));
			}
		}else{
			valorTotalCalle = calle.getPrecio();
			if(calle.getEstaSaboteado()){
				valorVenta = (int) (valorTotalCalle * (1 - PEN_VENTA_SABOTEADA));
			}else{
				valorVenta = (int) (valorTotalCalle * (1 - PEN_VENTA));
			}
		}
		
		String message = String.format(context.getString(R.string.infoVender), calle.getNombre(), valorVenta);
		builder.setMessage(message)
		       .setCancelable(false)
    	       .setPositiveButton(context.getString(R.string.butSi), new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		        	   dialog.cancel();
		        	   String title = context.getString(R.string.espere);
	        	       String text = context.getString(R.string.venderCalle);
	        			
	        	       AccionMenuVender.progressDialog = ProgressDialog.show(context, title, text, true, false);
	        	       AccionMenuVender.progressDialog.setIcon(R.drawable.ic_dialog_conexion);

			   	       Thread thread = new Thread(venderCalle);
			   	       thread.start();
		           }
		       }).setNegativeButton(context.getString(R.string.butNo), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(context.getString(R.string.vender));
    	alert.setIcon(R.drawable.ic_dialog_informacion);
    	alert.show();
	}
		
	private static Runnable venderCalle = new Runnable(){
		@Override
		public void run(){
			Looper.prepare();
			conexionVenderCalle();
			Looper.myLooper().quit();
			Looper.loop();
		}
		
		private void showToastConexion(){			
			Toast toast = Toast.makeText(context,
					context.getString(R.string.errConexion),
					Toast.LENGTH_SHORT);
			toast.show();
		}
		
		private void showToastDatos(){
			Toast toast = Toast.makeText(context,
					context.getString(R.string.errDatos),
					Toast.LENGTH_SHORT);
			toast.show();
		}
	
		private void showToastAceptada(){
			Toast toast = Toast.makeText(context,
					String.format(context.getString(R.string.calleVenderAceptada), calle.getNombre()),
					Toast.LENGTH_LONG);
			toast.show();
		}
		
		private void showToastRechazada(){
			Toast toast = Toast.makeText(context,
					String.format(context.getString(R.string.calleVenderRechazada), calle.getNombre()),
					Toast.LENGTH_LONG);
			toast.show();
		}
		
		public void conexionVenderCalle(){
			int resultado;
			try{
				DefaultHttpClient httpclient = new DefaultHttpClient();
				int idJuego = JuegoListar.getJuego().getIdentificador();
				int idEquipo = JuegoDatosListar.getEquipo().getIdentificador();
				int idCalle = AccionMenuVender.calle.getId();
				URI uri = new URI(GoldenStreets.urlServer+"juego/"+idJuego+"/equipo/"+idEquipo+"/calle/"+idCalle+"/vender/?format=json");

				HttpPost httpost = new HttpPost(uri);
				LibreGeoSocial LGS = LibreGeoSocial.getInstance();
				httpclient.setCookieStore(LGS.getCookieStore());
				
				List <NameValuePair> datos = new ArrayList <NameValuePair>();
				datos.add(new BasicNameValuePair("valorTotalCalle", Integer.toString(AccionMenuVender.valorTotalCalle)));
	            datos.add(new BasicNameValuePair("valorVenta", Integer.toString(AccionMenuVender.valorVenta)));
	            httpost.setEntity(new UrlEncodedFormEntity(datos, HTTP.UTF_8));
	            
	            HttpResponse response = httpclient.execute(httpost);
	            HttpEntity entity = response.getEntity();
	            String str = Utils.deStreamAString(entity.getContent());
				resultado = procesarRespuestaCalleVender(str);			

				handler.sendEmptyMessage(resultado);

			}catch(URISyntaxException urisex){
				Log.e(TAG, urisex.getMessage());
				handler.sendEmptyMessage(-1);
		    }catch (IOException e) {
		    	Log.e(TAG,e.getMessage());
		    	handler.sendEmptyMessage(-1);
		    }
		}
		
		private int procesarRespuestaCalleVender(String str) {
			int ultCode;
	    	String ultMensaje;
	        try {
	        	JSONObject json;
				json = new JSONObject(str);
				
				if (json.has("code"))
					ultCode = json.getInt("code");
				else
					ultCode = -1;
				
				if (json.has("descripcion"))
					ultMensaje = json.getString("descripcion");
				else
					ultMensaje = null;
				
				if (ultCode != 200){
					if (ultCode == 400 && ultMensaje.toLowerCase().compareTo("calle con modificaciones") == 0)
						return -3;
					return -2;
				}
			} catch (JSONException e) {	
				ultCode = 500;
				ultMensaje = "Error in json parsed: " + e.getMessage();
				Log.e(TAG, ultMensaje);
				return -2;
			}
			return 0;
		}
		
	    private Handler handler = new Handler()
	    {
	    	@Override
	        public void handleMessage(Message msg)
	        {
	        	int result = msg.what;
	        	AccionMenuVender.progressDialog.cancel();
	        	if(result == -3){
	        		showToastRechazada();
	        	}else if(result == -2){
	        		showToastDatos();
	        	}else if(result == -1){
	        		showToastConexion();
	        	}else if(result == 0){
	        		showToastAceptada();
	        	}
	        }
	    };
	};
}