package com.Goldenstreet.App.GoldenStreet;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;

import com.Goldenstreet.App.R;

/**
 * Clase auxiliar para tratar la recepcin de las acciones enviadas por los servicios en ejecucin.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class AccionesRecibidasBroadcast {
	private static Context context;
	
	public static AlertDialog accionCartaServicioNueva(Context context, Intent intent) {
		AccionesRecibidasBroadcast.context = context;
		Bundle bundle;
		bundle = intent.getExtras();
    	Carta carta = (Carta)bundle.getSerializable("carta");
    	CartaListar.setCarta(carta);
    	String cartaAccion;
    	switch(carta.getTipoAccion()){
    	case 1:
    		cartaAccion = context.getString(R.string.accion1);
    		break;
    	case 2:
    		cartaAccion = context.getString(R.string.accion2);
    		break;
    	case 3:
    		cartaAccion = context.getString(R.string.accion3);
    		break;
    	case 4:
    		cartaAccion = context.getString(R.string.accion4);
    		break;
    	case 5:
    		cartaAccion = context.getString(R.string.accion5);
    		break;
    	default:
    		cartaAccion = null;
    		break;
    	}
    	AlertDialog.Builder builder = new AlertDialog.Builder(context);
    	builder.setMessage(String.format(context.getString(R.string.infoCartaNueva), cartaAccion))
    	       .setCancelable(false)
    	       .setPositiveButton(context.getString(R.string.butInfo), new DialogInterface.OnClickListener() {
	               public void onClick(DialogInterface dialog, int id) {
	            	   Intent i = new Intent(AccionesRecibidasBroadcast.context, CartaInfo.class);
	            	   AccionesRecibidasBroadcast.context.startActivity(i);
    	        	   dialog.cancel();
	               }
    	       }).setNegativeButton(context.getString(R.string.butContinuar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(context.getString(R.string.informacion));
    	alert.setIcon(R.drawable.ic_dialog_informacion);
    	return alert;
	}
	
	public static AlertDialog accionCartaServicioSin(Context context, Intent intent) {
		AccionesRecibidasBroadcast.context = context;
		AlertDialog.Builder builder = new AlertDialog.Builder(context);
    	builder.setMessage(context.getString(R.string.infoSinCartas))
    	       .setCancelable(false)
    	       .setPositiveButton(context.getString(R.string.butContinuar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(context.getString(R.string.informacion));
    	alert.setIcon(R.drawable.ic_dialog_informacion);
    	Intent cartaServicio = new Intent(context, CartaServicio.class);
    	context.stopService(cartaServicio);
    	return alert;
	}
}