package com.Goldenstreet.App.GoldenStreet;

import com.LibreGeoSocial.Api.GeoNode;

/**
 * Representa cada calle perteneciente al juego y a su edificacin.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class Calle extends GeoNode {
	private static final long serialVersionUID = 7401488823460371975L;

	private int idPropietario;
	private String nombre;
	private int precio;
	private boolean estaConstruido;
	private boolean estaSaboteado;
	
	private String nombreEdificio;
	private int precioEdificio;
	private int bonificacionEdificio;
	
	public Calle(int identificador, int idPropietario, String nombreEdificio, int precioEdificio, 
			int bonificacionEdificio, String nombre, int precio, Double latitud, Double longitud, 
			Double altitud, Double radio, String since){	   
   		super(identificador, latitud, longitud, altitud, radio, since, null);
   		this.setIdPropietario(idPropietario);
   		this.setNombre(nombre);
   		this.setPrecio(precio);
   		this.setNombreEdificio(nombreEdificio);
   		this.setPrecioEdificio(precioEdificio);
   		this.setBonificacionEdificio(bonificacionEdificio);
	} 
		
	public int getIdPropietario() {
		return idPropietario;
	}	
	public void setIdPropietario(int idPropietario) {
		this.idPropietario = idPropietario;
	}	
	
	public String getNombre() {
		return nombre;
	}	
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}	
	
	public int getPrecio() {
		return precio;
	}
	public void setPrecio(int precio) {
		this.precio = precio;
	}
	
	public boolean getEstaConstruido() {
		return estaConstruido;
	}
	public void setEstaConstruido(boolean estaConstruido) {
		this.estaConstruido = estaConstruido;
	}

	public boolean getEstaSaboteado() {
		return estaSaboteado;
	}
	public void setEstaSaboteado(boolean estaSaboteado) {
		this.estaSaboteado = estaSaboteado;
	}
	
	public String getNombreEdificio() {
		return nombreEdificio;
	}
	public void setNombreEdificio(String nombreEdificio) {
		this.nombreEdificio = nombreEdificio;
	}
	
	public int getPrecioEdificio() {
		return precioEdificio;
	}
	public void setPrecioEdificio(int precioEdificio) {
		this.precioEdificio = precioEdificio;
	}
	
	public int getBonificacionEdificio() {
		return bonificacionEdificio;
	}
	public void setBonificacionEdificio(int bonificacionEdificio) {
		this.bonificacionEdificio = bonificacionEdificio;
	}

	public static Calle encontrarPorId(Calle calles[], int id){
   		Calle calle = null;
   		for (int i = 0; i < calles.length; i++){
   			if (calles[i].getId() == id)
   				calle = calles[i];
   		}
   		return calle;
   	}
   	
	public static Calle encontraPorNombre(Calle calles[], String nombre){
   		Calle calle = null;
   		for (int i = 0; i < calles.length; i++){
   			if (calles[i].getNombre().compareTo(nombre) == 0)
   				calle = calles[i];
   		}
   		return calle;
   	}
}