package com.Goldenstreet.App.GoldenStreet;

import java.io.Serializable;
import java.util.Iterator;
import java.util.List;

/**
 * Representa cada carta recibida por el equipo durante la partida.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class Carta implements Serializable{

	private static final long serialVersionUID = -3691543203479949718L;
	public static final int INGRESAR = 1;
	public static final int RETIRAR = 2;
	public static final int SABOTEAR = 3;
	public static final int CONSTRUIR = 4;
	public static final int DEMOLER = 5;
	
	/* Datos de la carta. */
    private int identificador;
	private String nombre;
	private int tipoAccion;
	private int cantidad;
	private String descripcion;
	private boolean usada;
	
	public Carta(Carta c){
		this.identificador = c.getIdentificador();
		this.nombre = c.getNombre();
		this.tipoAccion = c.getTipoAccion();
		this.cantidad = c.getCantidad();
		this.descripcion = c.getDescripcion();
		this.usada = c.getUsada();
	}
   	
	public Carta(int identificador, String nombre, int tipoAccion, int cantidad, String descripcion, boolean usada){
		this.setIdentificador(identificador);
   		this.setNombre(nombre);
   		this.setTipoAccion(tipoAccion);
   		this.setCantidad(cantidad);
   		this.setDescripcion(descripcion);
   		this.setUsada(usada);
   	}
	
   	public int getIdentificador() {
		return this.identificador;
	}
   	private void setIdentificador(int identificador) {
		this.identificador = identificador;
	}
    
   	public String getNombre() {
		return this.nombre;
	}
   	private void setNombre(String nombre) {
		this.nombre = nombre;
	}
   	
	public int getTipoAccion() {
		return this.tipoAccion;
	}
	private void setTipoAccion(int tipoAccion) {
		this.tipoAccion = tipoAccion;
	}
	
	public int getCantidad() {
		return this.cantidad;
	}
	private void setCantidad(int cantidad) {
		this.cantidad = cantidad;
	}
	
   	public String getDescripcion() {
		return this.descripcion;
	}
   	private void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	
	public boolean getUsada() {
		return this.usada;
	}
	public void setUsada(boolean usada) {
		this.usada = usada;
	}
	
   	public static Carta encontrarPorTipoSinUsar(List<Carta> cartas, int tipoAccion){
   		Carta carta = null;
   		Iterator<Carta> itr = cartas.iterator(); 
   		while(itr.hasNext()) {
   			carta = itr.next();
   			if ((carta.getTipoAccion() == tipoAccion) && (carta.getUsada() == false)){
   				return carta;
   			}
   		}
   		return null;
   	}
}