package com.Goldenstreet.App.GoldenStreet;

import com.Goldenstreet.App.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

/**
 * Muestra de forma detallada la informacin de la carta seleccionada (tipo, nombre, descripcin,
 * cantidad de dinero dependiendo del tipo e informacin de su uso).
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class CartaInfo extends Activity {
	//static private String TAG = "CartaInfo";
	
	private TextView textNombre;
	private TextView textTipo;
	private TextView textDescripcion;
	private TextView textNota;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.cartainfo);
        Carta carta = CartaListar.getCarta();
        
        textNombre = (TextView)this.findViewById(R.id.textNombre);
        textNombre.setText((String)carta.getNombre());
        
        textTipo = (TextView)this.findViewById(R.id.textTipo);
        String info = null;
        switch(carta.getTipoAccion()){
        case Carta.INGRESAR:
			info = getString(R.string.tipo)+getString(R.string.accion1)+" (+"+carta.getCantidad()+" )";
			break;
		case Carta.RETIRAR:
			info = getString(R.string.tipo)+getString(R.string.accion2)+" (-"+carta.getCantidad()+" )";
			break;
		case Carta.SABOTEAR:
			info = getString(R.string.tipo)+getString(R.string.accion3);
			break;
		case Carta.CONSTRUIR:
			info = getString(R.string.tipo)+getString(R.string.accion4);
			break;
		case Carta.DEMOLER:
			info = getString(R.string.tipo)+getString(R.string.accion5);
			break;
		}
        textTipo.setText((String)info);
        
        textDescripcion = (TextView)this.findViewById(R.id.textDescripcion);
        textDescripcion.setText((String)carta.getDescripcion());
        
        if (carta.getUsada()){
        	textNota = (TextView)this.findViewById(R.id.textNota);
        	textNota.setVisibility(View.GONE);
        }
    }
    
    @Override
    protected void onResume(){
		super.onResume();
		registerReceiver(receiver, new IntentFilter("CartaServicio.NUEVA"));
    	registerReceiver(receiver, new IntentFilter("CartaServicio.SIN"));
	}
    
    @Override
    protected void onPause(){
        super.onPause();       
        unregisterReceiver(receiver);
        finish();
    }
    
    private BroadcastReceiver receiver = new BroadcastReceiver() {        
        @Override
        public void onReceive(Context context, Intent intent) {
        	String accion = intent.getAction();
        	if (accion.equals("CartaServicio.NUEVA")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioNueva(context, intent);
		    	alert.show();
        	} else if(accion.equals("CartaServicio.SIN")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioSin(context, intent);
		    	alert.show();
        	}
        }
    };
}