package com.Goldenstreet.App.GoldenStreet;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.widget.Toast;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

/**
 * Clase auxiliar que aade a los equipos rivales y territorios, una capa de informacin 
 * que se visualizar cuando el equipo pulse sobre alguno de los recursos mostrados en el mapa.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class DatosMapaItemizedOverlay extends ItemizedOverlay<OverlayItem>{
	
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context context;
	
	public DatosMapaItemizedOverlay(Context context, Drawable defaultMarker) {
		super(boundCenterBottom(defaultMarker));
		this.context = context;
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}
	
	public void addOverlay(OverlayItem overlay){
		mOverlays.add(overlay);
		populate();
	}
	
	public void clearOverlay(){
		mOverlays.clear();
		populate();
	}

	@Override
	protected boolean onTap(int index) {
		Toast.makeText(context, mOverlays.get(index).getSnippet(), Toast.LENGTH_LONG).show();
		return super.onTap(index);
	}
}