package com.Goldenstreet.App.GoldenStreet;

import com.LibreGeoSocial.Api.Group;

/**
 * Representa cada equipo participante en el juego.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class Equipo extends Group{
	private static final long serialVersionUID = -2816945616323503048L;

	private int identificador;
	private Patrimonio patrimonio;
    	
   public Equipo(int identificador, String nombre, int idGrupo, Double latitud, Double longitud,
		   Double altitud, Double radio, String since){
   		
   		super(idGrupo, latitud, longitud, altitud, radio, since);
   		super.setGroupName(nombre);
   		this.setIdentificador(identificador);
   		this.setPatrimonio(new Patrimonio(0,0,0));
   	}
    
   	public int getIdentificador(){
   		return identificador;
   	}
   	private void setIdentificador(int identificador){
   		this.identificador = identificador;
   	}
   	
   	public Patrimonio getPatrimonio(){
   		return patrimonio;
   	}
   	private void setPatrimonio(Patrimonio patrimonio){
   		this.patrimonio = patrimonio;
   	}
	
   	public static Equipo encontrarPorId(Equipo equipos[], int id){
   		Equipo equipo = null;
   		for (int i = 0; i < equipos.length; i++){
   			if (equipos[i].getIdentificador() == id){
   				equipo = equipos[i];
   				break;
   			}
   		}
   		return equipo;
   	}
   	
	public static Equipo encontraPorNombre(Equipo equipos[], String nombre){
   		Equipo equipo = null;
   		for (int i = 0; i < equipos.length; i++){
   			if (equipos[i].getGroupName().equals(nombre)){
   				equipo = equipos[i];
   				break;
   			}
   		}
   		return equipo;
   	}
}