package com.Goldenstreet.App.GoldenStreet;

import com.Goldenstreet.App.R;
import com.Goldenstreet.App.GoldenStreet.Utils;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

/**
 * Muestra la pantalla de bienvenida a la aplicacin. Si el usuario no dispone de conexin
 * a internet y GPS, se le informar que son necesarios para poder participar en el juego.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class GoldenStreets extends Activity implements OnClickListener{
	//static private String TAG = "Goldenstreets";
	public static String urlServer;
	
	private Button buttonJugar;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.goldenstreetsinicio);
        buttonJugar = (Button)this.findViewById(R.id.buttonJugar);
        buttonJugar.setOnClickListener(this);
		boolean conectado = Utils.estaConectado(this);
		if (!conectado){
			showAlertConexion();
		}
    } 
    
    public void onClick(View v) {
    	if ( buttonJugar.isPressed() ){
    		boolean conectadoInternet = Utils.estaConectado(this);
    		if (!conectadoInternet){
    			showAlertConexion();
    			return;
    		}
    		
    		PosicionamientoServicio.setLocationManager((LocationManager)getSystemService(Context.LOCATION_SERVICE));
    		boolean conectadoGPS = PosicionamientoServicio.getLocationManager().isProviderEnabled(LocationManager.GPS_PROVIDER);
    		if (!conectadoGPS){
    			showAlertGPS();
    			return;
    		}
    		urlServer = "http://" + getString(R.string.urlServer).replaceFirst("/social/", "/goldenstreet/");
    		Intent i = new Intent(GoldenStreets.this, JuegoListar.class);
            this.startActivity(i);
        }
    }

    @Override
	public boolean onKeyDown(int keyCode, KeyEvent event){
		if (keyCode == KeyEvent.KEYCODE_BACK) {
    		AlertDialog.Builder builder = new AlertDialog.Builder(this);
    		builder.setMessage(getString(R.string.salirJuego))
		           .setCancelable(false)
		           .setPositiveButton(getString(R.string.butSi), new DialogInterface.OnClickListener() {
		               public void onClick(DialogInterface dialog, int id) {
		            	   dialog.cancel();
		            	   GoldenStreets.this.setResult(RESULT_OK);
		            	   GoldenStreets.this.finish();
		               }
		           })
		           .setNegativeButton(getString(R.string.butNo), new DialogInterface.OnClickListener() {
		               public void onClick(DialogInterface dialog, int id) {
		            	   dialog.cancel();
		               }
		           });
		    AlertDialog alert = builder.create();
		    alert.setTitle(getString(R.string.aviso));
		    alert.setIcon(R.drawable.ic_dialog_advertencia);
		    alert.show();
	    	return true;
	    }else{
	    	return false;
	    }
	}
    
	private void showAlertConexion(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	builder.setMessage(getString(R.string.errConexion))
    	       .setCancelable(false)
    	       .setPositiveButton(getString(R.string.butContinuar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(getString(R.string.aviso));
    	alert.setIcon(R.drawable.ic_dialog_advertencia);
    	alert.show();
	}
	
	private void showAlertGPS(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	builder.setMessage(getString(R.string.errConexionGPS))
    	       .setCancelable(false)
    	       .setPositiveButton(getString(R.string.butContinuar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(getString(R.string.aviso));
    	alert.setIcon(R.drawable.ic_dialog_advertencia);
    	alert.show();
	}
}