package com.Goldenstreet.App.GoldenStreet;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.Goldenstreet.App.R;

/**
 * Muestra de forma detallada la informacin del mensaje seleccionado (emisor, receptor, texto). El
 * equipo siempre tendr la opcin de responder a ese mensaje, pasando a una nueva activity para la
 * creacin y envo de mensajes.
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class MensajeInfo extends Activity implements OnClickListener {
	
	private Button buttonResponder;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mensajeinfo);
        TextView textDe = (TextView)this.findViewById(R.id.textDe);
        textDe.setText((String)getString(R.string.delEquipo).concat(MensajeListar.mensaje.getDelEquipo()));
        TextView textPara = (TextView)this.findViewById(R.id.textPara);
        textPara.setText((String)getString(R.string.paraEquipo).concat(MensajeListar.mensaje.getParaEquipo()));
        TextView textTexto = (TextView)this.findViewById(R.id.textTexto);
        textTexto.setText(MensajeListar.mensaje.getTexto());
        buttonResponder = (Button)this.findViewById(R.id.buttonResponder);
        buttonResponder.setOnClickListener(this);
    }
    
	@Override
	protected void onResume() {
		super.onResume();
		registerReceiver(receiver, new IntentFilter("CartaServicio.NUEVA"));
    	registerReceiver(receiver, new IntentFilter("CartaServicio.SIN"));
	}

	@Override
	protected void onPause() {
		super.onPause();
		unregisterReceiver(receiver);
		finish();
	}
    
    public void onClick(View v) {
    	if ( buttonResponder.isPressed() ){
    		Intent i = new Intent(MensajeInfo.this, MensajeNuevo.class);
            this.startActivity(i);
            MensajeInfo.this.setResult(RESULT_OK);
            MensajeInfo.this.finish();
        }
    }
    
    private BroadcastReceiver receiver = new BroadcastReceiver() {        
        @Override
        public void onReceive(Context context, Intent intent) {
        	String accion = intent.getAction();
        	if (accion.equals("CartaServicio.NUEVA")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioNueva(context, intent);
		    	alert.show();
        	} else if(accion.equals("CartaServicio.SIN")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioSin(context, intent);
		    	alert.show();
        	}
        }
    };
}