package com.Goldenstreet.App.GoldenStreet;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.Goldenstreet.App.R;

/**
 * Se muestra al equipo las opciones de listar las ofertas ya sean enviadas o recibidas. 
 * 
 * @author Rubn Quero Castrillo <rubenquero@gmail.com>
 * 
 */

public class OfertaMenu extends Activity implements OnClickListener {
	//static private String TAG = "OfertaMenu";
	
	private static final int MENU_INFORMAR = Menu.FIRST;
	private Button buttonOfertaRecibida;
	private Button buttonOfertaEnviada;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ofertamenu);
        buttonOfertaRecibida = (Button)this.findViewById(R.id.buttonOfertaRecibida);
        buttonOfertaRecibida.setOnClickListener(this);
        buttonOfertaEnviada = (Button)this.findViewById(R.id.buttonOfertaEnviada);
        buttonOfertaEnviada.setOnClickListener(this);
    }
    
	@Override
	protected void onResume() {
		super.onResume();
		registerReceiver(receiver, new IntentFilter("CartaServicio.NUEVA"));
    	registerReceiver(receiver, new IntentFilter("CartaServicio.SIN"));
	}

	@Override
	protected void onPause() {
		super.onPause();
		unregisterReceiver(receiver);
	}	
    
    public void onClick(View v) {
    	if ( buttonOfertaRecibida.isPressed() ){
    		Intent i = new Intent(OfertaMenu.this, OfertaListar.class);
    		i.putExtra("tipoOferta", "recibida");
            this.startActivity(i);
        }
    	if ( buttonOfertaEnviada.isPressed() ){
    		Intent i = new Intent(OfertaMenu.this, OfertaListar.class);
    		i.putExtra("tipoOferta", "enviada");
            this.startActivity(i);
        }
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu); 
        menu.add(0, MENU_INFORMAR, 0 , getString(R.string.informacion))
        .setIcon(R.drawable.ic_menu_informacion);
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	switch (item.getItemId()) {
    		case MENU_INFORMAR:
    			showAlertInformacion();
    			break;
    	}
    	return super.onOptionsItemSelected(item);
    }
    
    @Override
	public boolean onKeyDown(int keyCode, KeyEvent event){
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage(getString(R.string.salirJuego))
		           .setCancelable(false)
		           .setPositiveButton(getString(R.string.butSi), new DialogInterface.OnClickListener() {
		               public void onClick(DialogInterface dialog, int id) {
		            	   Utils.cerrarPartida(OfertaMenu.this);
		               }
		           })
		           .setNegativeButton(getString(R.string.butNo), new DialogInterface.OnClickListener() {
		               public void onClick(DialogInterface dialog, int id) {
		                    dialog.cancel();
		               }
		           });
		    AlertDialog alert = builder.create();
		    alert.setTitle(getString(R.string.aviso));
		    alert.setIcon(R.drawable.ic_dialog_advertencia);
		    alert.show();
	    	return true;
	    }else{
	    	return false;
	    }
	}

	private void showAlertInformacion(){
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	builder.setMessage(getString(R.string.infoOferta))
    	       .setCancelable(false)
    	       .setPositiveButton(getString(R.string.butContinuar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle(getString(R.string.informacion));
    	alert.setIcon(R.drawable.ic_dialog_informacion);
    	alert.show();
    }
	
    private BroadcastReceiver receiver = new BroadcastReceiver() {        
        @Override
        public void onReceive(Context context, Intent intent) {
        	String accion = intent.getAction();
        	if (accion.equals("CartaServicio.NUEVA")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioNueva(context, intent);
		    	alert.show();
        	} else if(accion.equals("CartaServicio.SIN")) {
        		AlertDialog alert = AccionesRecibidasBroadcast.accionCartaServicioSin(context, intent);
		    	alert.show();
        	}
        }
    };
}