from apps.goldenstreet.models import *
from social.core import api as api_lgs

def crear(nombre, ubicacion, juego):
    grupo = {'groupname': nombre.strip()}
    correcto, idGrupo = api_lgs.group.create_or_modify(grupo, modify=False)
    if correcto:
        grupo = Group.objects.get(id=idGrupo)
        nuevoEquipo = Equipo(grupo=grupo)
        nuevoEquipo.grupo.position = ubicacion
        nuevoEquipo.juegos = juego
        nuevoEquipo.save()

        nuevoPatrimonio = Patrimonio()
        nuevoPatrimonio.equipo = nuevoEquipo
        nuevoPatrimonio.juego = juego
        nuevoPatrimonio.dinero = juego.dineroInicial
        nuevoPatrimonio.valPatrimonio = juego.dineroInicial
        nuevoPatrimonio.save()
        return True, nuevoEquipo
    else:
        return False, 'El grupo ' + nombre + ' ya existe en LibreGeoSocial'

def modificar(equipo, nombre):
    equipo.grupo.name = nombre
    equipo.grupo.save()
    equipo.save()    
    return True, equipo

def modificarPosicion(equipo, ubicacion):
    equipo.grupo.position = ubicacion
    equipo.grupo.save()
    equipo.save()    
    return True, equipo

def listar(juego):
    return True, juego.equipo_set.all().order_by('id')

def listarPorPatrimonio(juego):
    return True, juego.equipo_set.all().order_by('id')

def coger(juego, equipoId):
    try:
      equipo = juego.equipo_set.get(id=equipoId)
      return True, equipo
    except:
      return False, 'Equipo invalido'

def borrar(equipo, usuarioId):
    calles = equipo.calle_set.all()
    for calle in calles:
        edificios = calle.edificio_set.all()
        for edificio in edificios:
            edificio.delete()
        calle.delete(usuarioId)
    patrimonios = equipo.patrimonio_set.all()
    for patrimonio in patrimonios:
        patrimonio.delete()
    mensajes = Mensaje.objects.all()
    for mensaje in mensajes:
        if mensaje.delEquipo == equipo:
            mensaje.delete()
    ofertas = Oferta.objects.all()
    for oferta in ofertas:
        if oferta.propietario == equipo or oferta.ofertante == equipo:
            oferta.delete()
    equipo.grupo.delete(usuarioId)
    equipo.delete()
    return True, 'Ok'
