from apps.goldenstreet.models import *

def crear(nombre, ubicacion, fechaInicio, dineroInicial, duracionInicial, usuarioId):
    nuevoJuego = Juego()
    nuevoJuego.nombre = nombre
    nuevoJuego.ubicacion = ubicacion
    nuevoJuego.fechaInicio = fechaInicio
    nuevoJuego.dineroInicial = dineroInicial
    nuevoJuego.duracion = duracionInicial
    nuevoJuego.save()

    usuario = Person.objects.get(id=usuarioId)
    organizador = Organizador.objects.get(usuario=usuario)
    organizador.juegos.add(nuevoJuego)
    organizador.save()

    return True, nuevoJuego

def modificar(juego, nombre, ubicacion, fechaInicio, dineroInicial, duracion):
    juego.nombre = nombre
    juego.ubicacion = ubicacion
    juego.fechaInicio = fechaInicio
    juego.dineroInicial = dineroInicial
    juego.duracion = duracion
    juego.save()
    return True, juego

def listar():
    return True, Juego.objects.all()

def coger(juegoId):
    try:
        juego = Juego.objects.get(id=juegoId)
        return True, juego
    except:
        return False, 'Juego invalido'

def borrar(juego, usuarioId):
    calles = juego.calle_set.all()
    for calle in calles:
        edificios = calle.edificio_set.all()
        for edificio in edificios:
            edificio.delete()
        calle.delete(usuarioId)
            
    mensajes = juego.mensaje_set.all()
    for mensaje in mensajes:
        mensaje.delete()
        
    ofertas = juego.oferta_set.all()
    for oferta in ofertas:
        oferta.delete()
        
    equipos = juego.equipo_set.all()
    for equipo in equipos:
        patrimonios = equipo.patrimonio_set.all()
        for patrimonio in patrimonios:
            patrimonio.delete()
        equipo.grupo.delete(usuarioId)
        equipo.delete()
    juego.delete()
    return True, 'Ok'

def establecerEstado(juego):
    if juego.estaCerrado:
        juego.estaCerrado = False
    else:
        juego.estaCerrado = True
    juego.save()
    return True, juego
