from apps.goldenstreet.models import *

def crear(juego, para, enviadoPor, destinatario, emisorId, texto):
    nuevoMensaje = Mensaje()
    nuevoMensaje.juego = juego
    nuevoMensaje.text = texto
    if enviadoPor == 'organizador':
        usuario = Person.objects.get(id=emisorId)
        organizador = Organizador.objects.get(usuario=usuario)
        nuevoMensaje.delOrganizador = organizador
    else:
        equipo = Equipo.objects.get(id=emisorId)
        nuevoMensaje.delEquipo = equipo
    nuevoMensaje.save()
    if para == 'unEquipo':
        nuevoMensaje.paraEquipos.add(destinatario)
    else:
        if para == 'organizador':
            nuevoMensaje.paraOrganizador = destinatario
        else:
            destinatarios = juego.equipo_set.all()
            for destinatario in destinatarios:
                nuevoMensaje.paraEquipos.add(destinatario)
    nuevoMensaje.save()

    return True, nuevoMensaje

def coger(juego, mensajeId):
    try:
        mensaje = juego.mensaje_set.get(id=mensajeId)
        return True, mensaje
    except:
        return False, 'Mensaje invalido'

def listar(juego):
    return True, juego.mensaje_set.all().order_by('id')

def listarPorEquipo(juego, equipo):
    try:
        mensajes = juego.mensaje_set.filter(delEquipo__id=equipo.id).order_by('-id') | juego.mensaje_set.filter(paraEquipos__id=equipo.id).order_by('-id')
        return True, mensajes
    except:
        return False, 'Mensajes invalidos'

def listarRecibidosPorEquipo(juego, equipo):
    try:
        mensajes = juego.mensaje_set.filter(paraEquipos__id=equipo.id).order_by('-id')
        return True, mensajes
    except:
        return False, 'Mensajes invalidos'

def borrar(mensaje):
    mensaje.delete()
    return True, 'Ok'
