from apps.goldenstreet.models import *
from django.db.models import F
from django.db.models import Q

def crear(juego, propietario, ofertante, calle, cantidad):
    nuevaOferta = Oferta()
    nuevaOferta.juego = juego
    nuevaOferta.propietario = propietario
    nuevaOferta.ofertante = ofertante
    nuevaOferta.calle = calle
    nuevaOferta.cantidad = cantidad
    nuevaOferta.save()
    return True, nuevaOferta

def modificar(oferta, respondida, aceptada):
    oferta.respondida = respondida
    oferta.aceptada = aceptada
    oferta.save()
    return True, oferta
              
def listarPorEquipoEnviada(juego, equipo):
    try:
        ofertas = juego.oferta_set.filter(ofertante__id=equipo.id).order_by('-id')
        return True, ofertas
    except:
        return False, 'Ofertas invalidas'

def listarPorEquipoRecibida(juego, equipo):
    try:
        ofertas = juego.oferta_set.filter(propietario__id=equipo.id).order_by('-id')
        return True, ofertas
    except:
        return False, 'Ofertas invalidas'

def listarPorEquipoRespondida(juego, equipo):
    try:
        ofertas = juego.oferta_set.filter(Q(ofertante__id=equipo.id) & Q(respondida=True)).order_by('-id')
        return True, ofertas
    except:
        return False, 'Ofertas invalidas'

def coger(ofertaId):
    try:
        oferta = Oferta.objects.get(id=ofertaId)
        return True, oferta
    except:
        return False, 'Oferta invalida'

def borrar(oferta):
    oferta.delete()
    return True, 'Ok'

def aceptar(juego, oferta, calleVersion, propietarioPatrimonio, ofertantePatrimonio):
    #try:
        updated = juego.calle_set.filter(Q(id=oferta.calle.id) & Q(equipo__id=propietarioPatrimonio.id) & Q(version=calleVersion))\
                  .update(version=F('version') + 1,
                          equipo = ofertantePatrimonio.equipo)
        if updated:
            updated = juego.oferta_set.filter(Q(calle__id=oferta.calle.id) & Q(respondida=False))\
                      .update(respondida=True,
                              aceptada=False)
            if updated:
                updated = juego.oferta_set.filter(Q(id=oferta.id))\
                          .update(aceptada=True)
                if updated:                
                    patrimonioVendido = oferta.calle.precio
                    if oferta.calle.estaConstruido:
                        patrimonioVendido = patrimonioVendido + Edificio.objects.get(calle__id=oferta.calle.id).precio           

                    propietarioPatrimonio.valPatrimonio = F('valPatrimonio') - patrimonioVendido
                    propietarioPatrimonio.dinero = F('dinero') + oferta.cantidad
                    propietarioPatrimonio.numPropiedades = F('numPropiedades') - 1
                    propietarioPatrimonio.save()

                    ofertantePatrimonio.valPatrimonio = F('valPatrimonio') + patrimonioVendido
                    ofertantePatrimonio.dinero = F('dinero') - oferta.cantidad
                    ofertantePatrimonio.numPropiedades = F('numPropiedades') + 1
                    ofertantePatrimonio.save()

                    return True, 'Ok'
                else:
                    oferta.calle.save()
                    return False, 'Oferta con modificaciones'
            else:
                oferta.calle.save()
                return False, 'Oferta con modificaciones'
        else:
            return False, 'Calle con modificaciones'
    #except:
    #    return False, 'Oferta invalida'

def rechazar(juego, ofertaId):
    try:
        updated = juego.oferta_set.filter(Q(id=ofertaId) & Q(respondida=False))\
                      .update(respondida=True,
                              aceptada=False)
        if updated:
            return True, 'Ok'
        else:
            return False, 'Oferta con modificaciones'
    except:
        return False, 'Oferta invalida' 

def retirar(juego, ofertaId):
    juego.oferta_set.filter(Q(id=ofertaId) & Q(respondida=False)).delete()
    try:
        juego.oferta_set.get(Q(id=ofertaId))
        return False, 'Oferta con modificaciones'
    except:
        return True, 'Ok'
