from django.conf.urls.defaults import *

STATIC_PROJECT_ROOT = 'C:/PFC/libregeosocial/'

urlpatterns = patterns('',
    (r'files/(?P<path>.*)$','django.views.static.serve',{'document_root': STATIC_PROJECT_ROOT+'apps/goldenstreet/templates'}),
    (r'img/(?P<path>.*)$','django.views.static.serve',{'document_root': STATIC_PROJECT_ROOT+'apps/goldenstreet/templates/images'}),
    (r'^$', 'apps.goldenstreet.rest.views.inicio'),

    #----Usuario----  
    (r'^login/$', 'apps.goldenstreet.rest.views.usuario_login'),
    (r'^logout/$', 'apps.goldenstreet.rest.views.usuario_logout'),
                       
    #----Juego----                 
    (r'^juego/crear/$', 'apps.goldenstreet.rest.views.juego_crear'),
    (r'^juego/listar/$', 'apps.goldenstreet.rest.views.juego_listar'),                 
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/mostrar/$', 'apps.goldenstreet.rest.views.juego_mostrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/modificar/$', 'apps.goldenstreet.rest.views.juego_modificar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.juego_borrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/establecer_estado/$', 'apps.goldenstreet.rest.views.juego_establecer_estado'),                      
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/seguimiento/$', 'apps.goldenstreet.rest.views.juego_seguimiento'),
        #----Juego-Datos----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/datos/listar/$', 'apps.goldenstreet.rest.views.juego_datos_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/datos/posicionar/$', 'apps.goldenstreet.rest.views.juego_datos_posicionar'),
        #----Juego-Mensaje----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/mensaje/crear/$', 'apps.goldenstreet.rest.views.mensaje_crear'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/mensaje/(?P<mensajeId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.mensaje_borrar'),
        #----Juego-Patrimonio----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/patrimonio/listar/$', 'apps.goldenstreet.rest.views.patrimonio_listar'),

    #----Equipo----                   
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/crear/$', 'apps.goldenstreet.rest.views.equipo_crear'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/listar/$', 'apps.goldenstreet.rest.views.equipo_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/mostrar/$', 'apps.goldenstreet.rest.views.equipo_mostrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/modificar/$', 'apps.goldenstreet.rest.views.equipo_modificar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.equipo_borrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/posicionar/$', 'apps.goldenstreet.rest.views.equipo_posicionar'),
        #----Equipo-Patrimonio----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/patrimonio/mostrar/$', 'apps.goldenstreet.rest.views.equipo_patrimonio_mostrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/propiedades/patrimonio/modificar/$', 'apps.goldenstreet.rest.views.equipo_patrimonio_modificar'),
        #----Equipo-Mensaje----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/mensaje/listar/$', 'apps.goldenstreet.rest.views.equipo_mensaje_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/mensaje/historico/$', 'apps.goldenstreet.rest.views.equipo_mensaje_historico'),
        #----Equipo-Oferta----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/oferta/(?P<tipoOferta>enviada|recibida)/listar/$', 'apps.goldenstreet.rest.views.equipo_oferta_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/oferta/historico/$', 'apps.goldenstreet.rest.views.equipo_oferta_historico'),
        #----Equipo-Carta----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/carta/usar/$', 'apps.goldenstreet.rest.views.equipo_carta_usar'),
        #----Equipo-Calle----                 
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/comprar/$', 'apps.goldenstreet.rest.views.equipo_calle_comprar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/vender/$', 'apps.goldenstreet.rest.views.equipo_calle_vender'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/construir/$', 'apps.goldenstreet.rest.views.equipo_calle_construir'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/sabotear/$', 'apps.goldenstreet.rest.views.equipo_calle_sabotear'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/demoler/$', 'apps.goldenstreet.rest.views.equipo_calle_demoler'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/ofertar/$', 'apps.goldenstreet.rest.views.equipo_calle_ofertar'), 
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/oferta/(?P<ofertaId>[1-9][0-9]*)/aceptar/$', 'apps.goldenstreet.rest.views.equipo_oferta_aceptar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/oferta/(?P<ofertaId>[1-9][0-9]*)/rechazar/$', 'apps.goldenstreet.rest.views.equipo_oferta_rechazar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/equipo/(?P<equipoId>[1-9][0-9]*)/oferta/(?P<ofertaId>[1-9][0-9]*)/retirar/$', 'apps.goldenstreet.rest.views.equipo_oferta_retirar'),
    #----Calle----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/crear/$', 'apps.goldenstreet.rest.views.calle_crear'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/listar/$', 'apps.goldenstreet.rest.views.calle_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/mostrar/$', 'apps.goldenstreet.rest.views.calle_mostrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/modificar/$', 'apps.goldenstreet.rest.views.calle_modificar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.calle_borrar'),
        #----Calle-Edificio----  
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/edificio/crear/$', 'apps.goldenstreet.rest.views.edificio_crear'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/edificio/listar/$', 'apps.goldenstreet.rest.views.edificio_listar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/edificio/(?P<edificioId>[1-9][0-9]*)/mostrar/$', 'apps.goldenstreet.rest.views.edificio_mostrar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/edificio/(?P<edificioId>[1-9][0-9]*)/modificar/$', 'apps.goldenstreet.rest.views.edificio_modificar'),
    (r'^juego/(?P<juegoId>[1-9][0-9]*)/calle/(?P<calleId>[1-9][0-9]*)/edificio/(?P<edificioId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.edificio_borrar'),
    #----Carta----                   
    (r'^carta/crear/$', 'apps.goldenstreet.rest.views.carta_crear'),
    (r'^carta/listar/$', 'apps.goldenstreet.rest.views.carta_listar'),
    (r'^carta/(?P<cartaId>[1-9][0-9]*)/mostrar/$', 'apps.goldenstreet.rest.views.carta_mostrar'),
    (r'^carta/(?P<cartaId>[1-9][0-9]*)/modificar/$', 'apps.goldenstreet.rest.views.carta_modificar'),
    (r'^carta/(?P<cartaId>[1-9][0-9]*)/borrar/$', 'apps.goldenstreet.rest.views.carta_borrar'),
)
